package cn.fastfun.config;

import com.bridge.dto.ApiDTO;
import com.bridge.exception.ApiRuntimeException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * 异常捕获
 */
@Slf4j
@ControllerAdvice
public class ApiExceptionHandler {

    @ExceptionHandler(value = ApiRuntimeException.class)
    public @ResponseBody
    ApiDTO errorHandler(HttpServletRequest request, ApiRuntimeException e) {
        if(e.getStatus() != 501)
            log.error("URL:{},异常捕获:{}", request.getRequestURI(), e.getMessage(), e);
        return ApiDTO.error(e.getStatus(), e.getMessage());
    }

    @ExceptionHandler(value = RuntimeException.class)
    public @ResponseBody
    ApiDTO errorHandler(HttpServletRequest request, Exception e) {
        log.error("URL:{},异常捕获:{}", request.getRequestURI(), e.getMessage(), e);
        return ApiDTO.error(e.getMessage());
    }
}
