package cn.fastfun.controller.api;

import cn.fastfun.controller.param.*;
import cn.fastfun.service.entity.AppAssetConf;
import cn.fastfun.service.impl.AppAssetConfServiceImpl;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bridge.dto.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * @author Bridge AutoGen
 */
@Slf4j
@Api(tags = {"2.0 资产配置界面"})
@RestController
@RequestMapping("/api/v1/appassetconf")
public class ApiAssetConfigureController {

    @Autowired
    AppAssetConfServiceImpl appAssetConfService;


    @ApiOperation(value = "增加/修改")
    @RequestMapping(value = "save", method = RequestMethod.POST)
    public ApiDTO save(@RequestBody @ApiParam(name = "增加/修改", value = "传入json格式", required = true) AppAssetConf appAssetConf) throws Exception {

        // 新增
        if (appAssetConf.getId() == null){
            Date date = new Date();
            appAssetConf.setAddTime(date);
            appAssetConf.setUpdateTime(date);
            appAssetConfService.save(appAssetConf);
            return ApiDTO.ok("新增成功");

        }
        else{
            appAssetConf.setUpdateTime(new Date());
            appAssetConfService.updateById(appAssetConf);
            return ApiDTO.ok("修改成功");
        }
    }

    @ApiOperation(value = "删除")
    @RequestMapping(value = "delete", method = RequestMethod.POST)
    public ApiDTO delete(@RequestBody @ApiParam(name = "增加/修改", value = "传入json格式", required = true) AppAssetConf appAssetConf) throws Exception {

        // 删除
        AppAssetConf assetConf = appAssetConfService.getById(appAssetConf.getId());
        assetConf.setUpdateTime(new Date());
        assetConf.setIsDelete(1);
        appAssetConfService.updateById(assetConf);
        return ApiDTO.ok("删除成功");
    }

    @ApiOperation(value = "查看")
    @RequestMapping(value = "query", method = RequestMethod.POST)
    public ApiDTO query(@RequestBody @ApiParam(name = "增加/修改", value = "传入json格式", required = true) AppAssetConf appAssetConf) throws Exception {

        // 查询
        AppAssetConf assetConf = appAssetConfService.getById(appAssetConf.getId());
        return ApiDTO.ok("查询成功",assetConf);
    }

    @ApiOperation(value = "列表查询")
    @RequestMapping(value = "pageQuery", method = RequestMethod.POST)
    public ApiDTO pageQuery(@RequestBody @ApiParam(name = "增加/修改", value = "传入json格式", required = true) AssetProfitParam appAssetConf) throws Exception {

        // 列表查询
        Page<AppAssetConf> page1 = appAssetConfService.appAssetConfPageQuery(appAssetConf);

        return ApiDTO.ok("查询成功", page1);

    }
}