package cn.fastfun.controller.dto.asset;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * 资产基础信息
 * @author user
 */
@Data
public class BasicAssetDto implements Serializable {

    private static final long serialVersionUID = -1821068317406106793L;

    /**
     * id
     */
    private String id;
    /**
     * imei
     */
    private String imei;
    /**
     * 产品类别编码
     */
    private String deviceType;
    /**
     * 产品类别：电池
     */
    private String deviceTypeText;
    /**
     * 厂家：格林美
     */
    private String factory;
    /**
     * 电芯：宁德
     */
    private String electricCore;
    /**
     * 设备编号：PK504B10000003457
     */
    private String sn;
    /**
     * 产品类型编码
     */
    private String productType;
    /**
     * 产品类型：两轮车
     */
    private String productTypeText;
    /**
     * 电芯类型编码 化学成分
     */
    private String electricCoreType;
    /**
     * 电芯类型：三元锂
     */
    private String electricCoreTypeText;
    /**
     * 扩展
     */
    private String extend;
    /**
     * 扩展
     */
    private String extendText;
    /**
     * 电压平台：72V
     */
    private Integer voltage;
    /**
     * 电压平台：72V
     */
    private String voltageText;
    /**
     * 容量：50Ah
     */
    private Integer capacity;
    /**
     * 容量：50Ah
     */
    private String capacityText;
    /**
     * 生产时间：2021-8-6
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private String createTime;
    /**
     * 投营时间：2021-8-15
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private String operationTime;
    /**
     * 采购价格：3250元
     */
    private BigDecimal purchasePrice;
    /**
     * 业务p状态编码
     */
    private Integer status;
    /**
     * 业务p状态名称：库存/在租/故障/返修
     */
    private String statusText;
    /**
     * 投营地区编码
     */
    private String location;
    /**
     * 投营地区名称
     */
    private String locationText;
}
