package cn.fastfun.controller.param;

import com.bridge.dto.QueryParam;
import com.bridge.dto.QueryParamExp;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.Date;
import java.util.List;

@Getter
@Setter
public class LibraryInQueryParam extends QueryParam{


    @ApiModelProperty(value = "设备编号", name = "sn", required = false)
    private String sn;


    @ApiModelProperty(value = "排序", name = "orderBy", required = false)
    private String orderBy;

    @ApiModelProperty(value = "自检状态", name = "checkStatus", example = "0, 0：未通过 ; 1:已通过;  空:全部")
    private Integer checkStatus;

    @ApiModelProperty(value = "入库时间起始", name = "recordTimeStart", required = true)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date recordTimeStart;

    @ApiModelProperty(value = "入库时间结束", name = "recordTimeEnd", required = true)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date recordTimeEnd;


}
