package cn.fastfun.service;

import cn.fastfun.controller.dto.LoginUser;
import cn.fastfun.service.entity.SysUser;
import com.bridge.dto.ApiDTO;

import java.util.Date;

/**
 * 通用工具服务类
 */
public interface UtilService {

    /**
     * 获得当前账号
     */
    LoginUser getUser();

    /**
     * 删除用户
     *
     * @param userId 用户ID
     */
    void clearLoginUser(String userId);

    /**
     * 账号登录
     *
     * @param userName 账号
     * @param userPass 密码
     */
    ApiDTO login(String userName, String userPass);

    /**
     * 重置登录账号
     *
     * @param sysUser 系统用户
     */
    void resetLoginUser(SysUser sysUser, Date date);

    /**
     * 获得当前用户ID
     *
     * @return
     */
    String getUserId();

    String getUserName();

}
