package cn.fastfun.service.entity;


import com.bridge.entity.IdEntity;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;


@Entity
@Table(name = "sys_excel_field")
@Setter
@Getter
@JsonIgnoreProperties(value = {"hibernateLazyInitializer"})
public class SysExcelField extends IdEntity {


    private static final long serialVersionUID = -5104366147522238024L;

    @ApiModelProperty(value = "文件名", name = "fileName", required = true)
    @Column(name = "file_name")
    private String fileName;

    @ApiModelProperty(value = "表名", name = "tableName", required = true)
    @Column(name = "table_name")
    private String tableName;

    @ApiModelProperty(value = "字段", name = "fieldName", required = true)
    @Column(name = "field_name")
    private String fieldName;

    @ApiModelProperty(value = "字段标题", name = "fieldTitle", required = true)
    @Column(name = "field_title")
    private String fieldTitle;

    @ApiModelProperty(value = "排序", name = "sort", required = true)
    @Column(name = "sort")
    private Integer sort;

    @ApiModelProperty(value = "必填", name = "required", required = true)
    @Column(name = "required")
    private Integer required;

    @ApiModelProperty(value = "字段类型", name = "objectName", required = true)
    @Column(name = "object_name")
    private String objectName;

    @ApiModelProperty(value = "宽度", name = "width", required = true)
    @Column(name = "width")
    private Integer width;

    @ApiModelProperty(value = "导入", name = "isImport", required = true)
    @Column(name = "is_import")
    private Integer isImport;

    @ApiModelProperty(value = "导出", name = "isExport", required = true)
    @Column(name = "is_export")
    private Integer isExport;
}
