package cn.fastfun.util;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class IrrUtil {
    /**
     * 迭代次数
     */
    public static int LOOP_NUM = 1000;
    /**
     * 最小差异
     */
    public static final BigDecimal MIN_DIF = new BigDecimal(1);


    /**
     * @param cashFlow 资金流
     * @return 收益率
     * @desc 使用方法参考main方法
     */
    public static double getIrr(List<BigDecimal> cashFlow) {
        BigDecimal flowOut = cashFlow.get(0);
        double minValue = 0d;
        double maxValue = 1d;
        double testValue = 0d;
        int index = 0;
        while (LOOP_NUM > 0) {

            testValue = (minValue + maxValue) / 2;
            BigDecimal npv = NPV(cashFlow, testValue);
            if (flowOut.add(npv).abs().compareTo(MIN_DIF) == -1) {
                System.out.println(index);
                break;
            } else if (flowOut.abs().compareTo(npv) == 1) {
                maxValue = testValue;
            } else {
                minValue = testValue;
            }
            index ++;
            LOOP_NUM--;
        }
        return testValue;
    }

    public static BigDecimal NPV(List<BigDecimal> flowInArr, double rate) {
        BigDecimal npv = new BigDecimal(0);
        for (int i = 1; i < flowInArr.size(); i++) {
            npv = npv.add(flowInArr.get(i).divide(new BigDecimal(Math.pow(1 + rate, i))));
        }
        return npv;
    }

    public static String main(BigDecimal price, List<BigDecimal> flowIn) {
        flowIn.add(0, price);
        return (IrrUtil.getIrr(flowIn)*100 +"%");
    }

}